
#include <iostream.h>
#include <math.h>

double min(double x, double y) {
  return x <= y ? x : y ;
}

class Point {
  double x ;
  double y ;
  friend double angle(Point, Point, Point) ;
public :
  Point(double X, double Y) : x(X), y(Y) {}
  void print() {
    cout << x << ", " << y ;
  }
} ;
 
double angle(Point P, Point Q, Point R) {

  // Actually cosine of angle

  double ux, uy, vx, vy ;
  double uu, vv ;

  ux = P.x - Q.x ;
  uy = P.y - Q.y ;
  vx = R.x - Q.x ;
  vy = R.y - Q.y ;

  uu = ux * ux + uy * uy ;
  vv = vx * vx + vy * vy ;

  if (uu > 0 && vv > 00) 
    return (ux * vx + uy * vy) / sqrt(uu * vv) ;
  else
    return -1.0 ;
}

class Triangle {
  Point P ;
  Point Q ;
  Point R ;
public :
  void angles(double* RPQ, double* PQR, double* QRP) {
    *RPQ = angle(R, P, Q) ;
    *PQR = angle(P, Q, R) ;
    *QRP = angle(Q, R, P) ;
  }
  Triangle(Point& p, Point& q, Point& r) : P(p), Q(q), R(r) {}
  Triangle() : P(Point(0.0, 0.0)), Q(Point(0.0, 0.0)), R(Point(0.0, 0.0)) {}
  void print(double&) ; 
} ;
 
 
void Triangle :: print(double& minAngle) {
  double RPQ = angle(R, P, Q) ;
  double PQR = angle(P, Q, R) ;
  double QRP = angle(Q, R, P) ;

  cout << RPQ << ", " << PQR << ", " << QRP ;

  minAngle = min(RPQ, min(PQR, QRP)) ;
}

void printTriangles(double x, double y, double z, double t,
                    double u, double v, double w) {
  Point A(0.0, 0.0) ;
  Point B(1.0, 0.0) ;
  Point C(1.0, 1.0) ;
  Point D(0.0, 1.0) ;
  Point E(x  , 0.0) ;
  Point F(0.0, y  ) ;
  Point G(z  , t  ) ;
  Point H(u  , v  ) ;
  Point I(w  , (1 - w) * t / (1 - z)) ;

  Triangle AEH(A, E, H) ;
  Triangle EBI(E, B, I) ;
  Triangle EIH(E, I, H) ;
  Triangle AHF(A, H, F) ;
  Triangle HGF(H, G, F) ;
  Triangle HIG(H, I, G) ;
  Triangle BCG(B, C, G) ;
  Triangle FGD(F, G, D) ;
  Triangle GCD(G, C, D) ;

  double minAngles [9] ;
  double minAngle = 1.0 ; 

  cout << "AEH: " ; AEH.print(minAngles [0]) ; cout << "\n" ;
  cout << "EBI: " ; EBI.print(minAngles [1]) ; cout << "\n" ;
  cout << "EIH: " ; EIH.print(minAngles [2]) ; cout << "\n" ;
  cout << "AHF: " ; AHF.print(minAngles [3]) ; cout << "\n" ;
  cout << "HGF: " ; HGF.print(minAngles [4]) ; cout << "\n" ;
  cout << "HIG: " ; HIG.print(minAngles [5]) ; cout << "\n" ;
  cout << "BCG: " ; BCG.print(minAngles [6]) ; cout << "\n" ;
  cout << "FGD: " ; FGD.print(minAngles [7]) ; cout << "\n" ;
  cout << "GCD: " ; GCD.print(minAngles [8]) ; cout << "\n" ;

  for(int i = 0 ; i < 9 ; i++)
    minAngle = min(minAngle, minAngles [i]) ;
  cout << "minimum cosine = " << minAngle << "\n" ;

  cout << "A: " ; A.print() ; cout << "\n" ;
  cout << "B: " ; B.print() ; cout << "\n" ;
  cout << "C: " ; C.print() ; cout << "\n" ;
  cout << "D: " ; D.print() ; cout << "\n" ;
  cout << "E: " ; E.print() ; cout << "\n" ;
  cout << "F: " ; F.print() ; cout << "\n" ;
  cout << "G: " ; G.print() ; cout << "\n" ;
  cout << "H: " ; H.print() ; cout << "\n" ;
  cout << "I: " ; I.print() ; cout << "\n" ;
}



double minAngle(double x, double y, double z, double t,
               double u, double v, double w) {
  Point A(0.0, 0.0) ;
  Point B(1.0, 0.0) ;
  Point C(1.0, 1.0) ;
  Point D(0.0, 1.0) ;
  Point E(x  , 0.0) ;
  Point F(0.0, y  ) ;
  Point G(z  , t  ) ;
  Point H(u  , v  ) ;
  Point I(w  , (1 - w) * t / (1 - z)) ;

  Triangle triangles [9] ;

  double result = 1.0 ;

  triangles [0] = Triangle(A, E, H) ;
  triangles [1] = Triangle(E, B, I) ;
  triangles [2] = Triangle(E, I, H) ;
  triangles [3] = Triangle(A, H, F) ;
  triangles [4] = Triangle(H, G, F) ;
  triangles [5] = Triangle(H, I, G) ;
  triangles [6] = Triangle(B, C, G) ;
  triangles [7] = Triangle(F, G, D) ;
  triangles [8] = Triangle(G, C, D) ;

  for(int i = 0 ; i < 9 ; i++) {
    double a, b, c ;

    triangles [i] . angles(&a, &b, &c) ;
    result = min(result, min(a, min(b, c))) ;
  }

  return result ;
}


const int L = 3 ;

main () {
  double X, Y, Z, T, U, V, W ;
  double maxMin ;
  double epsilon ;

  
  X = 0.5 ;
  Y = 0.5 ;
  Z = 0.5 ;
  T = 0.5 ;
  U = 0.5 ;
  V = 0.5 ;
  W = 0.5 ;

  epsilon = 1.0 / (2 * L) ;

  maxMin = minAngle(X, Y, Z, T, U, V, W) ;

  for ( ; ; ) {
    cout << "epsilon = " << epsilon << "\n" ;
    for ( ; ; ) {
      double x, y, z, t, u, v, w ;
      double xx, yy, zz, tt, uu, vv, ww ;
      double curr, next ;

      cout << maxMin << "\n" ;
      curr = maxMin ;
      for(int i = -L ; i <= L ; i++) {
	x = X + epsilon * i ;
	for(int j = -L ; j <= L ; j++) {
	  y = Y + epsilon * j ;
	  for(int k = -L ; k <= L ; k++) {
	    z = Z + epsilon * k ;
	    for(int l = -L ; l <= L ; l++) {
	      t = T + epsilon * l ;
	      for(int m = -L ; m <= L ; m++) {
		u = U + epsilon * m ;
		for(int n = -L ; n <= L ; n++) {
		  v = V + epsilon * n ;
		  for(int r = -L ; r <= L ; r++) {
		    w = W + epsilon * r ;

		    double next = minAngle(x, y, z, t, u, v, w) ;

		    if(next > curr) {
		      xx = x ;
		      yy = y ;
		      zz = z ;
		      tt = t ;
		      uu = u ;
		      vv = v ;
		      ww = w ;
		      curr = next ;
		    }
		  }
		}
	      }
	    }
	  }
	}
      }
      if(curr > maxMin) {
	X = xx ;
	Y = yy ;
	Z = zz ;
	T = tt ;
	U = uu ;
	V = vv ;
	W = ww ;
	maxMin = curr ;
      }
      else {
	printTriangles(X, Y, Z, T, U, V, W) ;
	goto jump ;
      }
    }
    jump :
    epsilon = epsilon / 2 ;
  }
}


